#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "RemailerDlgs.h"
#include "Pgpmail.h"
#include "global.h"
#include "view.h"

AnsiString cretbuf;
//---------------------------------------------------------------------------
AnsiString __fastcall CpkDir()
{
   return MixDir();
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkPublicRing()
{
   return CpkDir()+"pubring.asc";
}
//---------------------------------------------------------------------------
int __fastcall CpkKeyCount(TStrings *KeyDoc)
{
   int keys=0;
   for (int i=0; i<KeyDoc->Count; i++)
      if (KeyDoc->Strings[i].Trim()==BeginPgpPubKeyBlock)
         keys++;
   return keys;
}
//---------------------------------------------------------------------------
bool __fastcall cpkdb_getnext(TStringList *key, TStrings *keylist)
{
   key->Clear();
   AnsiString keyline;
   while (keylist->Count && keylist->Strings[0].IsEmpty()) keylist->Delete(0);
   if (!keylist->Count) return false;

   while (keylist->Count)
   {
      keyline = keylist->Strings[0];
      key->Add(keyline); keylist->Delete(0);
      if (keyline==EndPgpPubKeyBlock)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall CpkSortKeys(TStrings *Keys)
{
   TStringList *out = new TStringList();
   TStringList *key = new TStringList();
   while (cpkdb_getnext(key,Keys))
   {
      TStringList *keylines = new TStringList();
      keylines->Text = key->Text;
      out->AddObject(keylines->Strings[0],keylines);
   }
   Keys->Clear();
   out->Sorted = true;
   for (int i=0; i<out->Count; i++)
   {
      TStrings *next = dynamic_cast<TStringList*>(out->Objects[i]);
      if (next) { Keys->AddStrings(next); Keys->Add(""); }
   }
   delete key;
   delete out;
}
//---------------------------------------------------------------------------
void __fastcall CpkBlockToKeys(TStrings *Block)
{
   if (HasPgp())
   {
      Block->SetText(PgpArmorBlockToArmorKeys(Block->Text.c_str()));
      CpkSortKeys(Block);
   }
}
//---------------------------------------------------------------------------
void __fastcall CpkBlockToKeysClist(TStrings *Block, TStrings *Clist)
{
   TStringList *clist = new TStringList();
   if (HasPgp())
   {
      if (Clist) clist->AddStrings(Clist);
      else
      {
         if (FileExists(MixDir()+CListTxt)) clist->LoadFromFile(MixDir()+CListTxt);
      }
//view(s("1:\n"+Block->Text));
      TStringList *tmp = new TStringList();
      Block->SetText(PgpArmorBlockToArmorKeysCpk(Block->Text.c_str(),
         clist->Text.c_str()));
      delete clist;

      AnsiString line;
      while (Block->Count && Block->Strings[0].Pos("CTB=")!=1) Block->Delete(0);
      while (Block->Count)
      {
         int hasbegin=Block->IndexOf(BeginPgpPubKeyBlock)+1;
         int hasend=Block->IndexOf(EndPgpPubKeyBlock)+1;
         if (!hasbegin || !hasend || hasend<hasbegin)
            break;
//view(Block->Text,"block");
         tmp->Add(
            Block->Values["ShortName"]+" "+
            Block->Values["Addresses"]+" "+
            Block->Values["KeyId"]+
            "\r\n"
         );
//view(tmp->Text);

         while (Block->Strings[0]!=BeginPgpPubKeyBlock) Block->Delete(0);
         while (Block->Count)
         {
            line = Block->Strings[0]; Block->Delete(0);
            tmp->Add(line);
            if (line==EndPgpPubKeyBlock)
               break;
         }
      }
//view(Block);
      Block->Text = tmp->Text;
      Block->Add("");
      delete tmp;
   }
}
//---------------------------------------------------------------------------
void __fastcall CpkKeysToBlock(TStrings *Keys)
{
   if (HasPgp())
      Keys->SetText(PgpArmorKeysToArmorBlock(Keys->Text.c_str()));
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkRemLines(TStrings *CList)
{
   int p;
   AnsiString tmp,keyid,line,shrt,adrs,caps,clisttxt=MixDir()+CListTxt;
   TStringList *rems = new TStringList();
   if (CList==NULL && FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   else rems->Text = CList->Text;
   TStringList *lines = new TStringList();
   for (int r=0; r<rems->Count; r++)
   {
      line = rems->Strings[r].Trim();
      if (line.Pos("$remailer{")==1)
      {
         keyid = noCkeyfound;
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         adrs = GetParam(0,caps," ");
         caps = caps.SubString(adrs.Length()+2,512);
         while ((p=adrs.Pos("<"))>0 || (p=adrs.Pos(">"))>0) adrs.Delete(p,1);
         lines->Add(shrt+" "+adrs+" "+noCkeyfound+" "+caps);
      }
   }
   cretbuf = lines->Text;
   delete lines;
   delete rems;
   return cretbuf;
}
//---------------------------------------------------------------------------
#define BlkIndex(str) Block->IndexOf(str)
__fastcall TCpkKey::TCpkKey(TStrings *Key)
{
   status = ksKeyOk;
   if (Key->Count) Description = Key->Strings[0];
   int i=1; while (i<Key->Count && Key->Strings[i]!=BeginPgpPubKeyBlock) i++;
   Block = new TStringList();
   for (i=i; i<Key->Count; i++)
   {
      Block->Add(Key->Strings[i]);
      if (Key->Strings[i]==EndPgpPubKeyBlock)
         break;
   }
   if (Block->Count==0) status = ksEmptyKey; else
   if (Description.IsEmpty()) status = ksEmptyDescription; else
   if (BlkIndex(BeginPgpPubKeyBlock)<0 &&
       BlkIndex(EndPgpPubKeyBlock)<0) status = ksNoBeginNoEnd; else
   if (BlkIndex(BeginPgpPubKeyBlock)!=0) status = ksNoBegin; else
   if (BlkIndex(EndPgpPubKeyBlock)!=Block->Count-1) status = ksNoEnd;
}
//---------------------------------------------------------------------------
__fastcall TCpkKey::~TCpkKey()
{
   delete Block;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::TCpkDb(AnsiString PubRing)
{
   modified = false;
   keyring = PubRing;
   keys = new TStringList();
   if (!keyring.IsEmpty() && FileExists(keyring))
   {
      TStringList *key = new TStringList();
      TStringList *keyfile = new TStringList();
      keyfile->LoadFromFile(keyring);

      if (CpkKeyCount(keyfile)==1) CpkBlockToKeys(keyfile);

      while (cpkdb_getnext(key,keyfile)) AddKeyStrings(key);

      delete keyfile;
      delete key;
   }
   keys->Sorted = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::TCpkDb(TStrings *PubKeys)
{
   modified = false;
   keys = new TStringList(); keys->Sorted = true;
   if (PubKeys==NULL) return;

   keys = new TStringList();
   TStringList *key = new TStringList();
   TStringList *keylist = new TStringList();
   keylist->Text = PubKeys->Text;
   //if (CpkKeyCount(keylist)==1)
   CpkBlockToKeys(keylist);
   while (cpkdb_getnext(key,keylist)) AddKeyStrings(key);
   delete keylist;
   delete key;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::~TCpkDb()
{
   Clear();
   delete keys;
}
//---------------------------------------------------------------------------
TCpkKey* __fastcall TCpkDb::GetKey(int Pos)
{
   if (Pos<0 || Pos>=keys->Count) return NULL;
   return dynamic_cast<TCpkKey*>(keys->Objects[Pos]);
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::SaveToFile(AnsiString &FileName)
{
   TStringList *allkeys = new TStringList();
   SaveToStrings(allkeys);
   CpkKeysToBlock(allkeys);
   allkeys->SaveToFile(FileName);
   delete allkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::SaveToStrings(TStrings *Strings)
{
   Strings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      Strings->Add(key->Description);
      Strings->Add("");
      Strings->AddStrings(key->Block);
      Strings->Add("");
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkDb::SaveToString()
{
   TStringList *allkeys = new TStringList();
   SaveToStrings(allkeys);
   AnsiString keystr = allkeys->Text;
   delete allkeys;
   return keystr;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::AddKeyStrings(TStrings *Key)
{
   if (Key==NULL || !Key->Count) return -1;
   TCpkKey *key = new TCpkKey(Key);
   return AddKey(key);
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::AddKey(TCpkKey *Key)
{
   if (Key==NULL) return -1;
   TStringList *keylines = new TStringList();
   keylines->Add(Key->Description);
   keylines->Add("");
   keylines->AddStrings(Key->Block);
   TCpkKey *key = new TCpkKey(keylines);
   delete keylines;
   return keys->AddObject(key->Description,key);
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::Find(TCpkKey* Key)
{
   int pos=-1;
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      if (key && Key &&
          key->Description==Key->Description &&
          key->Block->Text==Key->Block->Text)
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::FindDescrip(AnsiString &Descrip)
{
   int pos=-1;
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      if (key && key->Description==Descrip)
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::Delete(int pos)
{
   if (pos<0 || pos>=keys->Count) return -1;
   delete dynamic_cast<TCpkKey*>(keys->Objects[pos]);
   keys->Delete(pos);
   modified = true;
   return pos;
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::Clear()
{
   while (keys->Count) Delete(0);
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *list)
{
   bool ok = false;
   for (int i=0; i<list->Count; i++)
   {
//if (remailer=="config@nym.xg.nu/admin@nym.xg.nu/send@nym.xg.nu/admin@nym.xg.nu 0x02D1ED81")
//sm(remailer+"\n"+list->Strings[i]);
      if (list->Strings[i]==remailer || list->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkGetNewRemailerKeys(TStrings *KeyDoc)
{
 // returns description lines of new, not disabled, keys
   AnsiString desc,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *t1 = new TStringList(); t1->Sorted = true;
   if (FileExists(ctyp1txt)) t1->LoadFromFile(ctyp1txt);
   TStringList *newkeys = new TStringList();
   TCpkDb *curdb = new TCpkDb(CpkPublicRing());
   TCpkDb *newdb = new TCpkDb(KeyDoc);
   for (int k=0; k<newdb->keys->Count; k++)
   {
      TCpkKey *key = newdb->GetKey(k);
      if (curdb->FindDescrip(key->Description)<0 && !InType1(key->Description,t1))
         newkeys->Add(key->Description);
   }
   cretbuf = newkeys->Text;
   delete newdb;
   delete curdb;
   delete newkeys;
   delete t1;
   return cretbuf;
}
//---------------------------------------------------------------------------
int __fastcall CpkAddNewRemailerKeys(TStrings *KeyDoc, TStrings *Type1)
{
   int added=0;
   // find new keys and add to curdb
   TCpkDb *curdb = new TCpkDb(CpkPublicRing());
   TCpkDb *newdb = new TCpkDb(KeyDoc);
   curdb->keys->Sorted = true;
   for (int k=0; k<newdb->keys->Count; k++)
   {
      TCpkKey *key = newdb->GetKey(k);
      if (curdb->FindDescrip(key->Description)<0 && !InType1(key->Description,Type1))
      {
         curdb->AddKey(key);
         added++;
      }
   }
   curdb->SaveToStrings(KeyDoc);
   delete newdb;
   delete curdb;
   return added;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkType1Doubles(TStrings *type1)
{
  int t,d;
  AnsiString s,id,line;
  TStringList *dbls = new TStringList();
  // get key ids in format             keyid=qty
  //                                 0x492FC66B=2
  for (t=0; t<type1->Count; t++)
  {
    if (type1->Strings[t].Pos("#")==1) continue;
    id = GetParam(1,type1->Strings[t]," ");
    // increment value
    int c = dbls->Values[id].ToIntDef(0);
    // assign incidence count
    dbls->Values[id] = AnsiString(c+1);
  }
  // remove non-duplicate items and just keep keyids without incidence count
  d=0; while(d<dbls->Count)
  {
     s = dbls->Strings[d];
     if (s.Pos("=1")==0) dbls->Strings[d++] = s.SubString(1,s.Pos("=")-1);
     else dbls->Delete(d);
  }
  // create actual display lines
  TStringList *dubs = new TStringList();
  for (d=0; d<dbls->Count; d++)
  {
     for (t=0; t<type1->Count; t++)
     {
        line = type1->Strings[t];
        if (line.Pos(dbls->Strings[d])>0)
           dubs->Add(line);
     }
     dubs->Add("");
  }
  cretbuf = dubs->Text;
  delete dubs;
  delete dbls;
  return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CpkRingLineOk(AnsiString &line)
{
   return GetParam(1,line," ").Pos("@")>0 && GetParam(2,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall CpkPopNextKey(TStrings *key, TStrings *keyring)
{
   key->Clear();
   AnsiString line;
   while (keyring->Count && keyring->Strings[0].Trim()!=BeginPgpPubKeyBlock)
      keyring->Delete(0);
   while (keyring->Count)
   {
      line = keyring->Strings[0];
      key->Add(line); keyring->Delete(0);
      if (line.Trim()==EndPgpPubKeyBlock)
         break;
   }
   return key->Count;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGenType1(TStrings *type1, TStrings *cring, TStrings *clist)
{
   AnsiString line;
   TStringList *lines = new TStringList();
   lines->Text = type1->Text; lines->Sorted = true;
   // remove all but disabled keys from type1.list
   int i=0; while (i<lines->Count)
   {
      line = lines->Strings[i];
      if (line.SubString(1,1)!="#") lines->Delete(i);
      else i++;
   }
   TStringList *ctemp = new TStringList();
   ctemp->Text = cring->Text;
   int c=0; for (int i=0; i<ctemp->Count; i++)
   {
      if (ctemp->Strings[i].Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----") c++;
      if (c>1) break;
   }
//view(ctemp);
   if (c==1) CpkBlockToKeysClist(ctemp,clist);
   // add keys from pubring.asc
   if (ctemp) for (i=0; i<ctemp->Count; i++)
   {
      line = ctemp->Strings[i];
      if (!CpkRingLineOk(line)) continue;

      if (!InType1(line,lines))
         lines->Add(line);
   }
   delete ctemp;
   // finish up
   type1->Text = lines->Text;
//view(type1);
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
bool __fastcall CpkOneInstance(AnsiString &ShortName, TStrings *clist)
{
   int inst=0;
   for (int i=0; i<clist->Count; i++)
      if (ShortName.LowerCase()==clist->Strings[i].LowerCase())
         inst++;
   return inst<2;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkListKeyNotFound(TStrings *clist, TStrings *type1)
{
   TStringList *nokeys = new TStringList();
   // if a short name is in clist and not type1, add it to nokeys
   AnsiString shrt,addr,typ1,cline,tline;
   for (int c=0; c<clist->Count; c++)
   {
      bool found = false;
      cline = clist->Strings[c].Trim();
      if (!CpkListLineOk(cline)) continue;

      addr = GetParam(1,cline," ");
      for (int t=0; t<type1->Count; t++)
      {
         tline = type1->Strings[t].Trim();
         if (!CpkRingLineOk(tline)) continue;

         if (tline.Pos(addr))
         {
            found = true;
            break;
         }
      }
      if (!found) nokeys->Add(
         GetParam(0,cline," ")+"  "+GetParam(1,cline," ") // short+" "+addr
      );
   }
//sm(type1->Text);
//sm("NO KEYS:\n"+nokeys->Text);
   cretbuf = nokeys->Text;
   delete nokeys;
   return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CpkListLineOk(AnsiString &wholeline)
{//0         1         2         3         4         5         6         7
 //012345678901234567890123456789012345678901234567890123456789012345678901
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=1; while (l<wholeline.Length() && wholeline[l]!=' ') l++;
   AnsiString line=wholeline.SubString(l,256).Trim();
   l=line.Length(); if (l<62) return false;
   bool ok = GetParam(0,line," ").Pos("@");
   if (ok) ok = line[l-10]==':';
   if (ok) ok = line[l-3]=='.';
   if (ok) ok = line[l]=='%';
 //sm(s(line[l])+"   "+s(l));
   return ok;
}
//---------------------------------------------------------------------------




