#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RemailerDlgs.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "Cyberpunk.h"
#include "PgpMail.h"
#include "HelpDlgs.h"
#include "docmsgdlg.h"
#include "smtpdlgs.h"
#include "deldocsdlg.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
TRemailerDlg *RemailerDlg;
AnsiString httpretval;
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   RemailerDlg = new TRemailerDlg(owner);
   CenterDialog(RemailerDlg,owner);
   bool ok = RemailerDlg->Execute(attended);
   delete RemailerDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc()
   : TStringList()
{
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc(AnsiString Docfile)
   : TStringList()
{
   if (FileExists(Docfile)) LoadFromFile(Docfile);
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
bool __fastcall FreshenType1(TRemailerDoc *Type1, TRemailerDoc *CRing,
   TRemailerDoc *CList, bool SaveToDisk)
{
   AnsiString md=MixDir();
   if (!FileExists(md+CRingTxt)) return false;

   bool deltype1=Type1==NULL; bool delcring=CRing==NULL; bool delclist=CList==NULL;
   if (!Type1) Type1 = new TRemailerDoc(md+CTyp1Txt);
   if (!CRing) CRing = new TRemailerDoc(md+CRingTxt);
   if (!CList) CList = new TRemailerDoc(md+CListTxt);
   CpkGenType1(Type1,CRing,CList);
   if (SaveToDisk) Type1->SaveToFile(md+CTyp1Txt);
   if (delcring) delete CRing;
   if (deltype1) delete Type1;
   if (delclist) delete CList;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall FreshenType2(TRemailerDoc *Type2, TRemailerDoc *MRing,
   bool SaveToDisk)
{
   AnsiString md=MixDir();
   if (!FileExists(md+MRingTxt)) return false;

   bool deltype2=Type2==NULL; bool delmring=MRing==NULL;
   if (!Type2) Type2 = new TRemailerDoc(md+MTyp2Txt);
   if (!MRing) MRing = new TRemailerDoc(md+MRingTxt);
   MixGenType2(Type2,MRing);
   if (SaveToDisk) Type2->SaveToFile(md+MTyp2Txt);
   if (deltype2) delete Type2;
   if (delmring) delete MRing;
   return true;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDlg::TRemailerDlg(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Clear();
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   TimeOut = GetAppIni(StatsTimeOut,"").ToIntDef(30);

   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   TabSheet2->TabVisible = false;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;

   AnsiString md=MixDir();
   clisttxt = md+CListTxt;
   cringtxt = md+CRingTxt;
   ctyp1txt = md+CTyp1Txt;
   mlisttxt = md+MListTxt;
   mringtxt = md+MRingTxt;
   mtyp2txt = md+MTyp2Txt;
   SelfUpdateMix = false;
   SelfUpdateCpk = false;

   Timer3->Enabled = true;
   //FreshenType1(NULL,NULL,NULL,save);
   //FreshenType2(NULL,NULL,save);
}
//---------------------------------------------------------------------------
__fastcall TRemailerDlg::~TRemailerDlg()
{
   for (int i=0; i<Tabs->Count; i++)
      delete dynamic_cast<TRemailerDoc*>(Tabs->Objects[i]);
   delete HttpCli1->RcvdStream;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::WMGetButtonClick(TMessage& Msg)
{
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall SetCBoxCur(TComboBox *cbox, int listpos)
{
   if (listpos<cbox->Items->Count) cbox->ItemIndex = listpos;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::LoadURLs()
{
   GetAppData(MListCBox->Items,StatsURLs+PS+MListTxt); SetCBoxCur(MListCBox,0);
   GetAppData(MRingCBox->Items,StatsURLs+PS+MRingTxt); SetCBoxCur(MRingCBox,0);
   GetAppData(MTyp2CBox->Items,StatsURLs+PS+MTyp2Txt); SetCBoxCur(MTyp2CBox,0);
   GetAppData(CListCBox->Items,StatsURLs+PS+CListTxt); SetCBoxCur(CListCBox,0);
   GetAppData(CRingCBox->Items,StatsURLs+PS+CRingTxt); SetCBoxCur(CRingCBox,0);
   GetAppURLs();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SaveErrChkLog(TRemailerDoc *Log)
{
   if (!Log || !Log->Count) return;
   TRemailerDoc *list = new TRemailerDoc();
   GetAppData(list,ErrChkLog);
   int max = GetAppIni(ErrChkLogMax,"").ToIntDef(16);
   while (max && list->Count>=max)
   {
      PutAppData(ErrChkLog+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr = SMTPPOP3logtime()+" "+Log->Strings[Log->Count-1];
   PutAppData(ErrChkLog+PS+logstr,Log);
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (ModalResult)
   {
      case mrOk: SaveStatistics(); break;
      case mrCancel:
         if (GoodTabs())
         {
            switch (MsgBoxHwnd(Handle,
               "Your new remailer docs are not saved!\n\nSave them now?",
               "Remailer Documents",MB_YESNOCANCEL))
            {
               case ID_CANCEL:
                  CanClose = false;
                  break;
               case ID_YES:
                  SaveStatistics();
                  break;
            }
         }
   }
   if (!CanClose) return;

   if (CancelAnyway) ModalResult = mrCancel;
   PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
   StoreHttpInfo();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CheckDocumentsExist()
{
   int reply;
   if (!Cancelled && !FileExists(mlisttxt) && MRingBox->Checked && !MListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'mlist.txt' document is missing. Shall I get it while online?",
        "Mixmaster Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MListBox->Checked = true;
            break;
      }
   }
   FreshenType2(NULL,NULL,save);

   if (!Cancelled && !FileExists(clisttxt) && CRingBox->Checked && !CListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "  Your 'rlist.txt' document is missing. Shall I get it while online?  ",
        "Cyberpunk Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CListBox->Checked = true;
            break;
      }
   }
   FreshenType1(NULL,NULL,NULL,save);
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ClearDocuments()
{
   for (int t=0; t<Tabs->Count; t++)
      delete dynamic_cast<TRemailerDoc*>(Tabs->Objects[t]);
   DocMemo->Clear();
   Tabs->Clear();
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::IsTab(int Index, AnsiString &TabName)
{
   if (Index>=0 && Index<Tabs->Count)
      return Tabs->Strings[Index]==TabName;
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetDocsClick(TObject *Sender)
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      return;
   }
   bool cancel=false;
   GetAppURLs(); CheckDocumentsExist();
   if (GoodTabs())
   {
      switch (MsgBoxHwnd(Handle,
         "You have good remailer docs not saved!\n\nSave them now?",
         "Remailer Documents",MB_YESNOCANCEL))
      {
         case ID_YES:
            SaveStatistics();
            break;
         case ID_CANCEL:
            cancel = true;
            break;
      }
   }
   if (cancel) return;
   ClearDocuments();
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ResetSelfUpdate()
{
  if (SelfUpdateMix)
  {
     MRingBox->Checked = false;
     SelfUpdateMix = false;
  }
  if (SelfUpdateCpk)
  {
     CRingBox->Checked = false;
     SelfUpdateCpk = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetBtnClick()
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      Cancelled = true;
   }
   if (Cancelled)
   {
      ResetSelfUpdate();
      ResetCheckboxes();
      return;
   }

   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetDocs->Enabled && GetDocs->Caption=="Get Docs")
   {
      TabSheet1->Enabled = false;
      TabSheet2->Enabled = false;
   }

   GetDocs->Enabled = false;
   OkBtn->Enabled = false;
   HelpBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes(); Label1->Caption = "";
      ProgressBar1->Visible = false; Label1->Caption = "";
      TabSet->TabIndex = Tabs->Count-1;
      if (ErrorCheck->Checked)
      {
         Sleep(200);
         TRemailerDoc *doc;
         Tabs->AddObject(ChecksPage,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Application->ProcessMessages();
         bool ok1=true,ok2=true,ok3=true,ok4=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            if (Cancelled) break;
            if ((doc=GetDoc(i))!=NULL)
            {
               if (IsTab(i,MListTxt)) ok1=MixListOk(doc); else
               if (IsTab(i,MRingTxt)) ok2=MixRingOk(doc); else
               if (IsTab(i,CListTxt)) ok3=CpkListOk(doc); else
               if (IsTab(i,CRingTxt)) ok4=CpkRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4 || Cancelled)
         {
            if (!Attended)
               Display("Operation cancelled");
            Display("Done!");
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetDocs->Enabled = true;
            HelpBtn->Enabled = true;
            OkBtn->Enabled = true;
            ResetSelfUpdate();
            GetBtnClick();
            return;
         }

         if (ReportDocumentsAndProblems()) Display("OK");
         else
         {
            if (!Attended)
               Display("Operation cancelled");
            Display("Done!");
            Attended = true;
         }
         AppProcessMessages(); Sleep(150);
      }

      ResetSelfUpdate();
      ActiveControl = DocMemo;
      ProgressBar1->Position = 100;
      AppProcessMessages(); Sleep(100);
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      GetDocs->Enabled = true;
      OkBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK); // if attended, just this line
      else
      {
         ModalResult = !Cancelled || (Cancelled && Tabs->Count>1) ? mrOk:mrCancel;
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         GetDocs->Enabled = false;
         OkBtn->Enabled = false;
         HelpBtn->Enabled = false;
         AppProcessMessages();
         Sleep(100);
      }
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDocument(AnsiString &DocName)
{
   int Index;
   AnsiString md=MixDir();
   TRemailerDoc *doc,*clist;
   // if the doc was not downloaded get it from disk
   Index=Tabs->IndexOf(DocName);
   if (Index>=0) doc = GetDoc(Index);
   else
   {
      doc = new TRemailerDoc();
      if (FileExists(md+DocName)) doc->LoadFromFile(md+DocName);
      Tabs->AddObject(DocName,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      Application->ProcessMessages(); Sleep(200);
      SetDoc(DocName,doc);
   }
   Index=Tabs->IndexOf(CListTxt);
   if (Index>=0) clist = GetDoc(Index);
   else
   {
      clist = new TRemailerDoc();
      if (FileExists(MixDir()+CListTxt)) doc->LoadFromFile(MixDir()+CListTxt);
      Tabs->AddObject(CListTxt,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      Application->ProcessMessages(); Sleep(200);
      SetDoc(CListTxt,clist);
   }
   // special handling cpunk keyring
   //if (DocName==CRingTxt && HasPgp()) CpkBlockToKeysClist(doc,clist);
   if (DocName==CRingTxt && HasPgp()) CpkBlockToKeys(doc);
   // end special
   SetDocMemo(doc);
   return doc;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CorruptDoc(TRemailerDoc *Doc)
{
   return Doc && Doc->Text.Trim().Pos(CorruptReport)==1;
}
//---------------------------------------------------------------------------
void __fastcall ClearTypeList(TRemailerDoc *TypeList)
{  // clears type1.list or type2.list of all but disables (#)
   int t=0; while (t<TypeList->Count)
   {
      if (TypeList->Strings[t].Pos("#")!=1) TypeList->Delete(t);
      else t++;
   }
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::ReportDocumentsAndProblems()
{
   bool mixOk=true,cpkOk=true;
   // LoadDocument returns a pointer to that document in the Tabs array.
   // If the document is not present on any Tab, it is loaded from disk
   // into the Tabs array. Either way, a pointer to the doc is returned.
   AnsiString md=MixDir();
   DocMemo->Cursor = crHourGlass;
   // test mixmaster documents
   if (Cancelled) return false;
   if (MListBox->Checked || MRingBox->Checked)
   {
      TRemailerDoc *mlist,*mring,*type2;
      mlist=GetDoc(MListTxt);
      type2=GetDoc(MTyp2Txt);
      if (Cancelled) return false;
      // if no pubring.mix, clear type2.list of all but disabled
      if (!FileExists(mringtxt) && type2) ClearTypeList(type2);
      // pubring.mix update
      if (MRingBox->Checked && !CorruptDoc(mring=GetDoc(MRingTxt)))
      {
         if (Cancelled) return false;
         mixOk =
            !Cancelled && MixCheckAddNewRemailerKeys(mring,type2,mlist) &&
            !Cancelled && MixCheckGenType2(type2,mring) &&
            !Cancelled && MixCheckType2NoDoubles(type2);
      }
      if (Cancelled) return false;
      // mlist.txt update -- compare new mlist.txt with type2.txt
      if (mixOk && MListBox->Checked && !CorruptDoc(mlist=GetDoc(MListTxt)))
         mixOk = !MixCheckListKeyNotFound(mlist,type2);
      if (Cancelled) return false;
   }
   // test cyberpunk documents
   if (CListBox->Checked || CRingBox->Checked)
   {
      TRemailerDoc *clist,*cring,*type1;
      clist=GetDoc(CListTxt);
      type1=GetDoc(CTyp1Txt);
      if (Cancelled) return false;
      // if no pubring.asc, clear type1.list of all but disabled
      if (!FileExists(md+CRingTxt) && type1) ClearTypeList(type1);
      // pubring.asc update
      if (CRingBox->Checked && !CorruptDoc(cring=GetDoc(CRingTxt)))
      {
         if (Cancelled) return false;
         cpkOk =
            !Cancelled && CpkCheckAddNewRemailerKeys(cring,type1,clist) &&
            !Cancelled && CpkCheckGenType1(type1,cring,clist) &&
            !Cancelled && CpkCheckType1NoDoubles(type1);
      }
      if (Cancelled) return false;
      // rlist.txt update -- compare new rlist.txt with type1.txt
      if (CListBox->Checked && !CorruptDoc(clist=GetDoc(CListTxt)) && cpkOk)
         cpkOk = !CpkCheckListKeyNotFound(clist,type1);
      if (Cancelled) return false;
   }
   DocMemo->Cursor = crDefault;
   return mixOk && cpkOk;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkCheckAddNewRemailerKeys(TRemailerDoc *CRing,
   TRemailerDoc *Type1, TRemailerDoc *CList)
{
   if (!CList && CListBox->Checked)
   {
      Display("rlist.txt...NOT RETRIEVED");
      Display(" Apparently your request for 'rlist.txt' was not");
      Display(" successful. Unable to perform error checks.");
      return false;
   }
   if (!CRing)
   {
      Display("pubring.asc...NOT RETRIEVED");
      Display(" Apparently your request for 'pubring.asc' was not");
      Display(" successful. Unable to perform error checks.");
      return false;
   }
   if (!Type1) return false;

   int added = CpkAddNewRemailerKeys(CRing,Type1);
   if (added>0)
   {
      Display(" pubring.asc...adding "+s(added)+" new keys");
      AppProcessMessages(); Sleep(250);
      Display("pubring.asc...OK");
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkCheckGenType1(TRemailerDoc *Type1, TRemailerDoc *CRing,
   TRemailerDoc *CList)
{
   if (!CRing || !Type1) return false;

   AnsiString line;
   int i,begs=0,ends=0;
   Display("type1.list...generating entries");
   for (i=0; i<CRing->Count; i++)
   {
      line = CRing->Strings[i];
      if (line.Trim()==BeginPgpPubKeyBlock) begs++; else
      if (line.Trim()==EndPgpPubKeyBlock) ends++;//else
      //if (CpkRingLineOk(line)) desc++;
   }
   if (begs==0 || begs!=ends)
   {
      AppProcessMessages();
      CRing->Insert(0,CorruptReport);
      Display("pubring.asc...CORRUPT");
      Display(" The new 'pubring.asc' document appears corrupt. The");
      Display(" values below should be equal AND greater than 0.");
      Display("  "+s(begs)+"  "+BeginPgpPubKeyBlock+" lines");
      Display("  "+s(ends)+"  "+EndPgpPubKeyBlock+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
      AppProcessMessages(); Sleep(150);
      return false;
   }
   AppProcessMessages(); Sleep(250);
   CpkGenType1(Type1,CRing,CList);
   Displas("type1.list...generating entries...OK");
   AppProcessMessages(); Sleep(250);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkCheckType1NoDoubles(TRemailerDoc *Type1)
{
   if (!Type1) return false;

   bool dbls=false;
   TStringList *items = new TStringList();
   Display("pubring.asc...checking duplicates");
   AppProcessMessages(); Sleep(500);
   items->Text = CpkType1Doubles(Type1);
   if (items->Count)
   {
      AppProcessMessages();
      Display("pubring.asc...DUPLICATE KEYS");
      Display(" The following keys on your Cyberpunk keyring appear");
      Display(" more than once. You will need to determine which is");
      Display(" current, and disable the older key. See Help");
      for (int i=0; i<items->Count; i++)
         if (!items->Strings[i].IsEmpty()) Display("  "+items->Strings[i]);
      AppProcessMessages(); Sleep(250);
      dbls = true;
   }
   if (!dbls) Displas("pubring.asc...checking duplicates...OK");
   AppProcessMessages(); Sleep(500);
   delete items;
   return !dbls;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkCheckListKeyNotFound(TRemailerDoc *CList,
   TRemailerDoc *Type1)
{
   if (!CList) return false; // !Type1 here...created below if NULL

   TRemailerDoc *type1 = new TRemailerDoc();
   if (Type1) type1->Text = Type1->Text;
   else if (FileExists(MixDir()+CTyp1Txt)) type1->LoadFromFile(MixDir()+CTyp1Txt);
   TStringList *items = new TStringList();

   bool found=false;
   Display("rlist.txt...comparing type1.list");
   AppProcessMessages(); Sleep(100);
   items->Text = CpkListKeyNotFound(CList,type1);
   if (items->Count)
   {
      AnsiString plu = items->Count==1 ? "" : "s";
      AnsiString cpkers = items->Count==1 ? "a Cpunk key" : "Cpunk keys";
      AppProcessMessages();
      Display("type1.list...KEY"+plu.UpperCase()+" NOT FOUND");
      Display(" There are "+s(items->Count)+s(" remailer")+s(plu)+s(" in your "));
      Display(" current Cyberpunk stats report (rlist.txt), for which, you ");
      Display(" have no public keys. You will probably want to obtain them. ");
      Display(" See Help");
      AppProcessMessages(); Sleep(250);
      found = true;
   }
   if (!found) Displas("rlist.txt...comparing type1.list...OK");
   AppProcessMessages(); Sleep(250);
   delete items;
   delete type1;
   return found;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixCheckAddNewRemailerKeys(TRemailerDoc *MRing,
   TRemailerDoc *Type2, TRemailerDoc *MList)
{
   if (!MList && MListBox->Checked)
   {
      Display("mlist.txt...NOT RETRIEVED");
      Display(" Apparently your request for 'mlist.txt' was not");
      Display(" successful. Unable to perform error checks.");
      return false;
   }
   if (!MRing)
   {
      Display("pubring.mix...NOT RETRIEVED");
      Display(" Apparently your request for 'pubring.mix' was not");
      Display(" successful. Unable to perform error checks.");
      return false;
   }
   if (!Type2) return false;

   int added = MixAddNewRemailerKeys(MRing,Type2);
   if (added)
   {
      Display("pubring.mix...adding "+s(added)+" new keys");
      AppProcessMessages(); Sleep(250);
      Displas("pubring.mix...adding "+s(added)+" new keys...OK");
      AppProcessMessages(); Sleep(250);
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixCheckGenType2(TRemailerDoc *Type2, TRemailerDoc *MRing)
{
   if (!Type2 || !MRing) return false;

   AnsiString line;
   int i,begs=0,ends=0,desc=0;
   Display("type2.list...generating entries");
   for (i=0; i<MRing->Count; i++)
   {
      line = MRing->Strings[i];
      if (line.Trim()==BeginMixKey) begs++; else
      if (line.Trim()==EndMixKey) ends++; else
      if (MixRingLineOk(line)) desc++;
   }
   if (!desc || desc!=begs || begs!=ends)
   {
      AppProcessMessages();
      MRing->Insert(0,CorruptReport);
      Display("pubring.mix...CORRUPT");
      Display(" The new 'pubring.mix' document appears corrupt. The");
      Display(" values below should ALL be greater than 0 AND equal.");
      Display("  "+s(desc)+"  Mixmaster key description lines");
      Display("  "+s(begs)+"  "+BeginMixKey+" lines");
      Display("  "+s(ends)+"  "+EndMixKey+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
      AppProcessMessages(); Sleep(250);
      return false;
   }
   AppProcessMessages(); Sleep(250);
   MixGenType2(Type2,MRing);
   Displas("type2.list...generating entries...OK");
   AppProcessMessages(); Sleep(250);
   return true;
}
//---------------------------------------------------------------------------
int __fastcall MixVerCompare(AnsiString ver1b, AnsiString ver2b)
{
//sm(ver1b+"   "+ver2b);
   int v1=ver1b.ToIntDef(-1),v2=ver2b.ToIntDef(-1);
   if (v1>v2) return 1;
   if (v2>v1) return 2;
   return 0;
}
int __fastcall MixVerHigher(AnsiString ver1, AnsiString ver2)
{
   ver1 = GetParam(3,ver1," "); ver2 = GetParam(3,ver2," ");
   if (ver1.SubString(1,3)=="2.9" && ver2.SubString(1,3)=="2.0") return 1;
   if (ver1.SubString(1,3)=="2.0" && ver2.SubString(1,3)=="2.9") return 2;
   if (ver1.SubString(1,5)=="2.0.4" && ver2.SubString(1,5)=="2.0.3") return 1;
   if (ver1.SubString(1,5)=="2.0.3" && ver2.SubString(1,5)=="2.0.4") return 2;

   if (ver1.SubString(1,5)=="2.0.4" && ver2.SubString(1,5)=="2.0.4")
      return MixVerCompare(ver1.SubString(7,8),ver2.SubString(7,8));

   if (ver1.SubString(1,3)=="2.9" && ver2.SubString(1,3)=="2.9")
      return MixVerCompare(ver1.SubString(8,8),ver2.SubString(8,8));

   return 0;
}
void __fastcall MixDupDisable(AnsiString &dup, TStrings *type2)
{
   for (int i=0; i<type2->Count; i++)
   {
      AnsiString t2line=type2->Strings[i];
      if (dup==t2line)
      {
         type2->Strings[i] = "#"+t2line;
         break;
      }
   }
}
void __fastcall MixDupDelete(AnsiString &dup1, AnsiString &dup2, TStrings *dups)
{
   for (int i=0; i<dups->Count; i++)
   {
      if (dups->Strings[i]==dup1) dups->Delete(i);
      break;
   }
   for (int i=0; i<dups->Count; i++)
   {
      if (dups->Strings[i]==dup2) dups->Delete(i);
      break;
   }
}
bool __fastcall MixNamesEqual(AnsiString &dup1,AnsiString &dup2)
{
   return GetParam(0,dup1," ")==GetParam(0,dup2," ");
}
bool __fastcall MixAddrsEqual(AnsiString &dup1, AnsiString &dup2)
{
   return GetParam(1,dup1," ")==GetParam(1,dup2," ");
}
bool __fastcall MixKeyidEqual(AnsiString &dup1, AnsiString &dup2)
{
   return GetParam(2,dup1," ")==GetParam(2,dup2," ");
}
//---------------------------------------------------------------------------
void __fastcall MixDupFixup(TStrings *Dups, TStrings *Type2)
{
   if (!Dups->Count) return;
   AnsiString ver1,ver2,dup2,dup1;
   TStringList *dups = new TStringList(); dups->Text = Dups->Text;
   while(dups->Count>0)
   {
      int i=0; dup1 = dups->Strings[i]; dups->Delete(i);
      while (i<dups->Count)
      {
         dup2 = dups->Strings[i];
         if (!MixNamesEqual(dup1,dup2)) continue;
         else dups->Delete(i);

//sm("1\n"+dup1+"\n"+dup2);
         if (MixAddrsEqual(dup1,dup2) && MixKeyidEqual(dup1,dup2))
         {
            switch (MixVerHigher(dup1,dup2))
            {
               case 1:
                  MixDupDelete(dup1,dup2,Dups);
                  MixDupDisable(dup2,Type2);
                  break;
               case 2:
                  MixDupDelete(dup1,dup2,Dups);
                  MixDupDisable(dup1,Type2);
                  break;
            }
         }
         break;
      }
   }
   delete dups;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixCheckType2NoDoubles(TRemailerDoc *Type2)
{
  if (!Type2) return false;

  bool dbls=false;
  TStringList *items = new TStringList();
  items->Text = MixType2Doubles(Type2);
  Display("pubring.mix...checking duplicates");
  AppProcessMessages(); Sleep(250);
  //MixDupFixup(items,Type2);
  if (items->Count)
  {
     AppProcessMessages();
     Display("pubring.mix...DUPLICATE KEYS");
     Display(" The following keys on your mixmaster keyring appear");
     Display(" more than once. You will need to determine which is");
     Display(" current, and disable the older key. See Help");
     for (int i=0; i<items->Count; i++) Display("  "+items->Strings[i]);
     AppProcessMessages(); Sleep(250);
     dbls = true;
  }
  if (!dbls) Displas("pubring.mix...checking duplicates...OK");
  AppProcessMessages(); Sleep(250);
  delete items;
  return !dbls;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixCheckListKeyNotFound(TRemailerDoc *MList, TRemailerDoc *Type2)
{
   if (!MList) return false; // not !Type2 here
   TRemailerDoc *type2 = new TRemailerDoc();
   if (Type2) type2->Text = Type2->Text; else
   if (FileExists(MixDir()+MTyp2Txt)) type2->LoadFromFile(MixDir()+MTyp2Txt);
   TStringList *items = new TStringList;
// fixing Type2 list to be in results window
//
   Display("mlist.txt...comparing type2.list");
   AppProcessMessages(); Sleep(250);

   bool found=false;
   items->Text = MixListKeyNotFound(MList,type2);
   if (items->Count)
   {
      AppProcessMessages();
      AnsiString plu = items->Count==1 ? "" : "s";
      Display("pubring.mix...KEY"+plu.UpperCase()+" NOT FOUND");
      if (items->Count==1)
      Display(" There is 1 remailer in your current mixmaster stats"); else
      Display(" There are "+s(items->Count)+" remailers in your current mixmaster stats");
      Display(" report (mlist.txt), for which, you have no public key"+plu+".");
      for (int i=0; i<items->Count; i++) Display("  "+items->Strings[i]);
      Display(" You will probably want to obtain them. See Help");
      AppProcessMessages(); Sleep(250);
      found = true;
   }
   if (!found) Displas("mlist.txt...comparing type2.list...OK");
   AppProcessMessages(); Sleep(100);
   delete items;
   delete type2;
   return found;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::SaveStatistics()
{
   if (!GoodTabs()) return false;

   TRemailerDoc *TxtList;
   int i,bakcopies=STATSBAKCOPIES;
   AnsiString TxtFile,mtyp2txt=MixDir()+MTyp2Txt,ctyp1txt=MixDir()+CTyp1Txt;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      TxtList = GetDoc(i);
      TxtFile = Tabs->Strings[i];
//sm(TxtFile);
      if (TxtList==NULL) continue;
      if (TxtList->Text.IsEmpty()) continue;
      if (TxtFile=="Error") continue;
      if (TxtFile==ChecksPage) { SaveErrChkLog(TxtList); continue; }
    // type1 or type2
    // if (TxtFile==MTyp2Txt) FreshenType2(TxtList,GetDoc(MRingTxt),!save);
    // if (TxtFile==CTyp1Txt) FreshenType1(TxtList,GetDoc(CRingTxt),!save);
      // special for pubring.asc, make single keyblock
      if (ErrorCheck->Checked && HasPgp() && TxtFile==CRingTxt)
         CpkKeysToBlock(TxtList);
      //==Save Statistics======================================
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
      //=======================================================
//sm("2: "+TxtFile);
   }
   return true;
}
//---------------------------------------------------------------------------
int __fastcall TRemailerDlg::GoodTabs()
{
   int valtabs=0;
   for (int i=0; i<Tabs->Count; i++)
   {
      TRemailerDoc *doc = GetDoc(i);
      if (Tabs->Strings[i]=="Error" || Tabs->Strings[i]==ChecksPage) continue;
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
    //if (doc->Modified)
      valtabs++;
   }
   return valtabs;
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::TabDoc(int Index)
{
   // returns doc from tab or null if corrupt
   if (Index<0 || Index>=Tabs->Count) return NULL;
   TRemailerDoc *Doc = GetDoc(Index);
   if (Doc && Doc->Count && Doc->Text.Pos(CorruptReport)==1)
      Doc = NULL;
   return Doc;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetTab(int Index)
{
   if (Index>=0 && Index<Tabs->Count) // make sure tabdoc = docmemo
   {
      TRemailerDoc *doc = GetDoc(Index);
      if (!doc)
      {
         doc = new TRemailerDoc();
         Tabs->Objects[Index] = doc;
      }
      doc->Text = DocMemo->Lines->Text;
      DocMemo->Modified = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Timer2Timer(TObject *Sender)
{
//   Timer2->Enabled = false;
//   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormShow(TObject *Sender)
{
   ActiveControl = Panel2;
   if (!Attended)
   {
      //LoadURLs();
      PostMessage(Handle,WM_GETBUTTONCLICK,0,NULL);
      //Timer2->Enabled = true;
      //return;
   }
   LoadURLs();
}
//---------------------------------------------------------------------------
AnsiString KeyRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkListOk(TRemailerDoc *Doc)
{
   AnsiString line,statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int i,pos;
   for(int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      while ((pos=line.Pos("&lt;"))>0) line.Delete(pos,4);
      while ((pos=line.Pos("&gt;"))>0) line.Delete(pos,4);
      if (line!=Doc->Strings[i]) Doc->Strings[i] = line;
   }
   if (Doc->Text.Pos(statsheader)==0)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics column headings.");
      Display(" \"remailer  email address        history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
    //Display("rlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   int c=0;
   for (i=0; i<Doc->Count; i++)
      if (CpkListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it. See Help");
    //Display("rlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   Display("rlist.txt...OK");
   AppProcessMessages(); Sleep(500);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkRingOk(TRemailerDoc *Doc)
{
   int begs=0,ends=0;
   for (int i=0; i<Doc->Count; i++)
   {
      AnsiString line=Doc->Strings[i].Trim();
      if (line==BeginPgpPubKeyBlock) begs++; else
      if (line==EndPgpPubKeyBlock) ends++; //else
    //if (CpkRingLineOk(line) desc++;
   }
   if (begs==0 || begs!=ends)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("pubring.asc...CORRUPT");
      Display(" The new 'pubring.asc' document appears corrupt. The");
      Display(" values below should BOTH be greater than 0 AND equal.");
      Display(" "+s(begs)+" "+BeginPgpPubKeyBlock+" lines");
      Display(" "+s(ends)+" "+EndPgpPubKeyBlock+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it."),
    //Display("pubring.asc...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }

   if (!HasPgp()) return true;

   TRemailerDoc *newkeys = new TRemailerDoc();
   newkeys->Text = CpkGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   if (newkeys->Count)
   {
      AppProcessMessages();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      Display("pubring.asc..."+s(newkeys->Count)+" NEW KEY"+s.UpperCase());
      Display(" The new 'pubring.asc' contains "+s(newkeys->Count)+" new key"+s+". These will be");
      Display(" added to your Cyberpunk keyring.");
      for (int k=0; k<newkeys->Count; k++)
         Display("  "+newkeys->Strings[k]);
      AppProcessMessages(); Sleep(500);
   }
   delete newkeys;
   Display("pubring.asc...OK");
   AppProcessMessages(); Sleep(200);
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Display(AnsiString &text)
{
   ActiveControl = DocMemo;
   DocMemo->Lines->Add(text);
   Application->ProcessMessages();
   Sleep(10);
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Displas(AnsiString &text)
{
   DocMemo->Lines->Strings[DocMemo->Lines->Count-1] = text;
   Application->ProcessMessages();
   Sleep(10);
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixListOk(TRemailerDoc *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics columns headings.");
      Display(" \"mixmaster           history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
    //Display("mlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages();
      return false;
   }
   int c=0; for (int i=0; i<Doc->Count; i++)
      if (MixListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it.");
    //Display("mlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   Display("mlist.txt...OK");
   AppProcessMessages(); Sleep(200);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixRingOk(TRemailerDoc *Doc)
{
   int desc=0,begs=0,ends=0;
   AnsiString line,descrip,s;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (line==BeginMixKey) begs++; else
      if (line==EndMixKey) ends++; else
      if (MixRingLineOk(line)) desc++;
   }
   if (!desc || desc!=begs || begs!=ends)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("pubring.mix...CORRUPT");
      Display(" The new 'pubring.mix' document appears corrupt. The");
      Display(" values below should be greater than 0 AND equal.");
      Display("  "+KeyRingCnt(desc)+"  Mixmaster key description lines");
      Display("  "+KeyRingCnt(begs)+"  "+BeginMixKey+" lines");
      Display("  "+KeyRingCnt(ends)+"  "+EndMixKey+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
      AppProcessMessages(); Sleep(300);
      return false;
   }
   // doc is ok, check for new keys
   TRemailerDoc *newkeys = new TRemailerDoc();
   newkeys->Text = MixGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      s = newkeys->Count==1 ? "" : "s";
      AppProcessMessages();
      Display("pubring.mix..."+s(newkeys->Count)+" NEW KEY"+s.UpperCase());
      Display(" The new 'pubring.mix' contains "+s(newkeys->Count)+" new key"+s+". These will be");
      Display(" added to your Mixmaster keyring.");
      for (int i=0; i<newkeys->Count; i++)
      {
         descrip = "";
         for (int f=0; f<5; f++)
         {
            if (f==1) descrip = descrip+s("           ").SubString(1,11-descrip.Length());
            descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         }
         Display("  "+descrip.Trim());
      }
      AppProcessMessages(); Sleep(500);
   }
   Display("pubring.mix...OK");
   AppProcessMessages(); Sleep(200);
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;

   BytesReceived = 0;
   TimeOutTimer->Enabled = true;
   CurTime = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       //GetDocs->Enabled = true;
       TabSheet1->Enabled = true;
       TabSheet2->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       TimeOutTimer->Enabled = false;

       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::LoadHttpInfo()
{
   TRemailerDoc *http = new TRemailerDoc();
   if (AppDataExists(HttpInfo,http))
   {
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::StoreHttpInfo()
{
   TRemailerDoc *http = new TRemailerDoc();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ResetCheckboxes()
{
   Timer1->Enabled = false;

   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;

   TabSheet1->Enabled = true;
   TabSheet2->Enabled = true;
   Cancelled = false;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      if (BytesReceived==BytesTotal) Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDoc(AnsiString DocName, TRemailerDoc *Doc)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index>=0 && Index<Tabs->Count)
   {
      TRemailerDoc *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDoc(int Index, TRemailerDoc *Doc)
{
   if (Index>=0 && Index<Tabs->Count)
   {
      TRemailerDoc *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDoc(AnsiString DocName)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TRemailerDoc*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDoc(int Index)
{
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TRemailerDoc*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::NeedsMixKeysUpdate(TRemailerDoc *MixList)
{
   if (!FileExists(mringtxt)) return true;
   TRemailerDoc *type2 = new TRemailerDoc(mtyp2txt);
   TRemailerDoc *mring = new TRemailerDoc(mringtxt);
   MixGenType2(type2,mring);
   bool need = !MixListKeyNotFound(MixList,type2).IsEmpty();
   delete type2;
   delete mring;
   return need;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::NeedsCpkKeysUpdate(TRemailerDoc *CpkList)
{
   if (!FileExists(cringtxt)) return true;
   TRemailerDoc *cring = new TRemailerDoc(cringtxt);
   TRemailerDoc *type1 = new TRemailerDoc(ctyp1txt);
   TRemailerDoc *clist = new TRemailerDoc(clisttxt);
   CpkGenType1(type1,cring,clist);
   bool need = !CpkListKeyNotFound(CpkList,type1).IsEmpty();
   delete clist;
   delete type1;
   delete cring;
   return need;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   int pos;
   TRemailerDoc *list;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TRemailerDoc *tmp = new TRemailerDoc();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      TimeOutTimer->Enabled = false;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         TimeOutTimer->Enabled = false;
         list = new TRemailerDoc();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         list->LoadFromStream(HttpCli1->RcvdStream);
         Tabs->AddObject(CurDoc,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Label1->Caption = "";
         SetDoc(CurDoc,list);
         AppProcessMessages();

         // handle html
         AnsiString doc = list->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (list->Count && list->Strings[0].UpperCase().Trim()!="<PRE>")
               list->Delete(0); if (list->Count) list->Delete(0);
            while (list->Count && list->Strings[list->Count-1].UpperCase().Trim()!="</PRE>")
               list->Delete(list->Count-1);
            if (list->Count) list->Delete(list->Count-1);
         }
         // get rid of stupid banner  << these may make a bogus report empyt
         if (CurDoc==CListTxt &&
            (pos=list->Text.Pos("$remailer{"))>0 && list->Text.Pos("Last update: ")>pos)
         {
            // dump the banner--bring the caps portion of list to top
            while (list->Count && list->Strings[0].Pos("$remailer{")!=1)
               list->Delete(0);
            // remove all trailing null
            while (list->Count && list->Strings[list->Count-1].IsEmpty())
               list->Delete(list->Count-1);
            // add 1 trailing null
            list->Add("");
            // move all lines above 'Last update: ' to bottom
            if (list->Count && list->Strings[0].Pos("$remailer{")==1)
            while (list->Strings[0].Pos("Last update: ")!=1)
            {
               list->Add(list->Strings[0]);
               list->Delete(0);
            }
            // remove double skipped lines--leave 1 skipped line
            s = list->Text;
            while ((pos=s.Pos("\r\n\r\n\r\n"))>0) s.Delete(pos,2);
            list->Text = s;
         }
         // get rid of stupid remailer banner
         if (CurDoc==MListTxt && list->Text.Pos("Last update: "))
            while (list->Count && !list->Strings[0].Pos("Last update: "))
               list->Delete(0);
         // set document
         SetDocMemo(list,false);
         AppProcessMessages(); Sleep(500);
         CurBox->Enabled = false;
         AppProcessMessages();

         // auto select keyring for update
         if (CurDoc==MListTxt && !MRingBox->Checked && NeedsMixKeysUpdate(list))
         {
            MRingBox->Checked = true;
            SelfUpdateMix = true;
         }
         if (CurDoc==CListTxt && !CRingBox->Checked && NeedsCpkKeysUpdate(list) && HasPgp())
         {
            CRingBox->Checked = true;
            SelfUpdateCpk = true;
         }
         //
         if (CurDoc==MRingTxt && ErrorCheck->Checked && HasMix())
         {
            GetDocument(MTyp2Txt);
            AppProcessMessages();
            Sleep(500);
         }
         else
         if (CurDoc==CRingTxt && ErrorCheck->Checked && HasPgp())
         {
            GetDocument(CTyp1Txt);
            Application->ProcessMessages(); Sleep(500);
         }
         else Sleep(300);

         if (PageControl1->ActivePage!=TabSheet3)
            PageControl1->ActivePage=TabSheet3;

         GetBtnClick();
         delete HttpCli1->RcvdStream; HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRemailerDlg::GetDefaultURL(AnsiString &DocName)
{
   AnsiString URL;
   if (DocName==MListTxt) URL = MListCBox->Text;
   if (DocName==MRingTxt) URL = MRingCBox->Text;
   if (DocName==MTyp2Txt) URL = MTyp2CBox->Text;
   if (DocName==CListTxt) URL = CListCBox->Text;
   if (DocName==CRingTxt) URL = CRingCBox->Text;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;
   if ((CRingURL = GetDefaultURL(CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CancelBtnClick(TObject *Sender)
{
   //Cancelled = true;
   TimeOutTimer->Enabled = false;
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   HelpBtn->Enabled = true;
   Attended = true;
   if (!GetDocs->Enabled)
   {
      GetDocs->Enabled = true;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::UrlsBtnClick(TObject *Sender)
{
   if (ManageURLs(this,ErrorCheck->Checked))
   {
      MListCBox->Clear();
      MRingCBox->Clear();
      MTyp2CBox->Clear();
      CListCBox->Clear();
      CRingCBox->Clear();
      AppProcessMessages();
      Sleep(200);
      LoadURLs();
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDocMemo(TRemailerDoc *Doc, bool SaveCur)
{
   int Index=TabSet->TabIndex;
   if (SaveCur && Index>=0 && Index<Tabs->Count && DocMemo->Modified)
   {
      TRemailerDoc *doc = new TRemailerDoc();
      doc->Text = DocMemo->Lines->Text;
      SetDoc(Index,doc);
   }
   DocMemo->Clear();
   if (Doc)
      DocMemo->Lines->Text = Doc->Text;
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   SetRedraw(DocMemo,false);
   TRemailerDoc *doc=new TRemailerDoc();
   doc->Text = DocMemo->Lines->Text;
   int Index = TabSet->TabIndex;
   if (Index>=0 && Index<Tabs->Count && DocMemo->Modified)
       SetDoc(Index,doc);

   doc = GetDoc(NewTab);
   DocMemo->Lines->Text = doc ? doc->Text:AnsiString("");
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
   SetRedraw(DocMemo,true);
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width - 92;
   CancelBtn->Left = HelpBtn->Left - 75;
   OkBtn->Left = CancelBtn->Left - 75;
   GetDocs->Left = OkBtn->Left - 75;
   ProgressBar1->Width = GetDocs->Left - 30;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2CBox->Visible = false;
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     MTyp2CBox->Visible = true;
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CRingBoxClick(TObject *Sender)
{
   if (CRingBox->Checked) CListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::MRingBoxClick(TObject *Sender)
{
   if (MRingBox->Checked) MListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *tab = PageControl1->ActivePage;
   if (tab==TabSheet1)
   {
      sections="Remailer\nRemailerUrl";
      if (ErrorCheck->Checked)
      {
         sections += "\nRemailerError";
//         if (HasMix()) sections += "\nUpdateMixDocs";
//         if (HasPgp()) sections += "\nUpdateCpkDocs";
//         if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//Application->MainForm);
   }
   else
   if (tab==TabSheet2)
   {
      OpenHelp("ProxyHTTP","Remailer Documents and Proxies","Proxy Host",NULL);//Application->MainForm);
   }
   else
   if (tab==TabSheet3)
   {
      sections="RemailerError";
      if (ErrorCheck->Checked)
      {
//         sections += "\nRemailerError";
//         if (HasMix()) sections += "\nUpdateMixDocs";
//         if (HasPgp()) sections += "\nUpdateCpkDocs";
//         if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//AppMainForm);
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ProxyBtnClick(TObject *Sender)
{
   TabSheet2->TabVisible = true;
   PageControl1->ActivePage = TabSheet2;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::DocCBoxChange(TObject *Sender)
{
/*
   TComboBox *cb = dynamic_cast<TComboBox*>(Sender);
   AnsiString def=cb->Text;
   cb->Items->Delete(cb->Items->IndexOf(def));
   cb->Items->Insert(0,def);
   cb->ItemIndex = 0;
   switch(cb->Tag)
   {
      case 1: PutAppData(StatsURLs+PS+MListTxt,cb->Items); break;
      case 2: PutAppData(StatsURLs+PS+MRingTxt,cb->Items); break;
      case 3: PutAppData(StatsURLs+PS+MTyp2Txt,cb->Items); break;
      case 4: PutAppData(StatsURLs+PS+CListTxt,cb->Items); break;
      case 5: PutAppData(StatsURLs+PS+CRingTxt,cb->Items); break;
   }
*/
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::TimeOutTimerTimer(TObject *Sender)
{
   CurTime++;
   if (CurTime>=TimeOut)
   {
      HttpCli1->Abort();
      TimeOutTimer->Enabled = false;
      Timer1->Enabled = false; Label1->Caption = "";
      AppProcessMessages(); Sleep(300);
      switch (MsgBoxHwnd(Handle,
         s("Hi ! I didn't get '"+CurDoc+"'...the connection timed out. The\n")+
         s("server may be down. I'll continue with any remaining docs.\n")+
         s("You may need to try another URL for "+CurDoc+".\n\n")+
         s("Would you like to try again before continuing?"),
         s(CurDoc.UpperCase()+" Timed Out"),
         MB_YESNOCANCEL))
      {
         case IDCANCEL: CancelBtn->Click(); break;
         case IDNO : CurBox->Enabled = false;
         case IDYES: GetBtnClick();
      }
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::OpenRemailerDoc(AnsiString &Docname)
{
   if (!FileExists(MixDir()+Docname)) return NULL;
   PageControl1->ActivePage = TabSheet3;

   TRemailerDoc *doc;
   AnsiString md=MixDir();
   // if the doc was not downloaded get it from disk
   int Index=Tabs->IndexOf(Docname);
   if (Index>=0)
   {
      doc = GetDoc(Index);
      if (FileExists(md+Docname)) doc->LoadFromFile(md+Docname);
      AppProcessMessages(); Sleep(200);
   }
   else
   {
      doc = new TRemailerDoc();
      if (FileExists(md+Docname)) doc->LoadFromFile(md+Docname);

      Tabs->AddObject(Docname,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      AppProcessMessages(); Sleep(200);
      SetDoc(Docname,doc);
   }
   // special handling type1 and type2
   if (Docname==MTyp2Txt) FreshenType2(GetDoc(MTyp2Txt),GetDoc(MRingTxt),save);
   if (Docname==CTyp1Txt) FreshenType1(GetDoc(CTyp1Txt),GetDoc(CRingTxt),
      GetDoc(CListTxt),save);
   // special handling cpunk keyring
   if (Docname==CRingTxt && HasPgp()) CpkBlockToKeysClist(doc,NULL);//,GetDoc(CListTxt));//GetDoc(CListTxt));
   // end special
   doc->Modified = false;
   doc->OpenDoc;
   SetDocMemo(doc);
   return doc;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::OpenRemailerDocClick(TObject *Sender)
{
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item) switch (item->Tag)
   {
      case 1: OpenRemailerDoc(MListTxt); break;
      case 2: OpenRemailerDoc(MRingTxt); break;
      case 3: OpenRemailerDoc(MTyp2Txt); break;
      case 4: OpenRemailerDoc(CListTxt); break;
      case 5: OpenRemailerDoc(CRingTxt); break;
      case 6: OpenRemailerDoc(CTyp1Txt); break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::OpenBtnClick(TObject *Sender)
{
   TStringList *files = new TStringList();
   files->Text = OpenChosenDocuments(this);
   if (files->Count) PageControl1->ActivePage = TabSheet3;
   for (int i=0; i<files->Count; i++)
   {
      OpenRemailerDoc(files->Strings[i]);
      AppProcessMessages(); Sleep(200);
   }
   delete files;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::DeleteBtnClick(TObject *Sender)
{
   TStringList *files = new TStringList();
   files->Text = ClearChosenDocuments(this);
   for (int i=0; i<files->Count; i++)
   {
      AnsiString file = MixDir()+files->Strings[i];
      DeleteFile(file.c_str());
   }
   delete files;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Timer3Timer(TObject *Sender)
{
   // do these time-consuming chores after dialog opens
   Timer3->Enabled = false;
   FreshenType1(NULL,NULL,NULL,save);
   FreshenType2(NULL,NULL,save);
}
//---------------------------------------------------------------------------
