//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyImptDlgs.h"
#include "Cyberpunk.h"
#include "pgpmail.h" // NoNameYet macro
#include "Global.h"
#include "View.h"
//---------------------------------------------------------------------------
#pragma link "MixKeyImptDlgs"
#pragma resource "*.dfm"
TCpkKeyImptDlg *CpkKeyImptDlg;
const AnsiString CpkNoKeysFoundAtAll = "...NO KEYS FOUND AT ALL!";
const AnsiString CpkLoading = "Loading...";
//---------------------------------------------------------------------------
bool __fastcall ImportCyberpunkKeys(TForm *Owner, TCpkKeyList *keylist,
   TCpkKeyList *ImpKeys, TCpkKeyList *DupKeys, AnsiString &ImportDir)
{
   CpkKeyImptDlg = new TCpkKeyImptDlg(Owner,keylist,ImpKeys,DupKeys,ImportDir);
   CpkKeyImptDlg->ShowModal();
   bool ok = CpkKeyImptDlg->ModalResult==mrOk &&
      (ImpKeys->Count || DupKeys->Count);
   delete CpkKeyImptDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner)
  : TMixKeyImptDlg(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner, TMixKeyList *Keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys, AnsiString &ImportDir)
   : TMixKeyImptDlg(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner, TCpkKeyList *Keylist,
   TCpkKeyList *ImpKeys, TCpkKeyList *DupKeys, AnsiString &ImportDir)
   : TMixKeyImptDlg(Owner)
{
   CenterDialog(this);
   impdir = &ImportDir;
   OpenDialog->InitialDir = *impdir;
   OpenDialog->Filter = "Cyberpunk key files (*.asc)|*.asc|All files (*.*)|*.*";
   OpenDialog->DefaultExt = ".asc";
   OpenDialog->FileName = "*.asc";
   ComboBox1->Items->Text = "Import Keys to Pubring.asc";
   ComboBox1->ItemIndex = 0;
   keylist = Keylist;
   implist = ImpKeys;
   implist->Clear();
   duplist = DupKeys;
   duplist->Clear();
   dislist = new TCpkKeyList();
   cap = Caption;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImptDlg::ImportKeys(AnsiString Name, AnsiString Ascii)
{
   implist->Clear();
   duplist->Clear();
   dislist->Clear();
   RichEdit1->Clear();
   TrashBtn->Enabled = false;
   Caption = "";

   int newcnt=0,dupcnt=0,discnt=0;
   AnsiString s,cshort,curdesc,desc,keytext,orglines=Ascii;
   TStringList *key = new TStringList();
   TStringList *keys = new TStringList();
   ImportBtn->Enabled = false;

   keys->Text = Ascii;
   while (keys->Count && keys->Strings[0].Trim().IsEmpty()) keys->Delete(0);
   if (keys->Count && keys->Strings[0]==BeginPgpPubKeyBlock)
      CpkBlockToKeysFull(keys);

   SetRedraw(Panel1,0);
   while (CpkGetNextKey(desc,key,keys)) // in cyberpunk.cpp
   {
      if (desc.Pos(NoNameYet)==1) continue;

      bool dis=false,dup=false;
      // is the key already in type2
      if (keylist->IndexOf(desc)>=0) //|| probs->IndexOf(desc)>=0)
      {
         dislist->AddKey(desc,key);
         dis = true;
         discnt++;
      }
      // No? Is the remailer shortname in type2
      if (!dis)
      {
         cshort = GetToken(0,desc," ");
         for (int i=0; i<keylist->Count; i++)
         {
            if (cshort==GetToken(0,keylist->Strings[i]," "))
            {
               duplist->AddKey(desc,key);
               dup = true;
               dupcnt++;
               break;
            }
         }
      }
      // if neither above this is a new key
      if (!dis && !dup)
      {
         implist->AddKey(desc,key);
         newcnt++;
      }
   }

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (newcnt)
   {
      RichEdit1->Lines->Add(Name+"..."+s(newcnt)+" NEW KEY"+s.UpperCase());
      for (int i=0; i<newcnt; i++)
         RichEdit1->Lines->Add(" "+implist->Strings[i]);
   }
   else
   {
      if (dupcnt || discnt) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
      else RichEdit1->Lines->Add(Name+CpkNoKeysFoundAtAll);
   }
   // duplicates
   if (dupcnt)
   {
      // new style
      RichEdit1->Lines->Add(Name+"..."+s(dupcnt)+" DUPLICATE KEY"+s.UpperCase());
      for (int i=0; i<dupcnt; i++)
         RichEdit1->Lines->Add(" "+duplist->Strings[i]);
   }
   if (!newcnt && !dupcnt) RichEdit1->Lines->Add(Name+"...DONE");
   else
   {
      RichEdit1->Lines->Add(Name+"...OK");
      ImportBtn->Enabled = true;
   }

   AppProcessMessages();
   SetRedraw(Panel1,1);
   Caption = cap;
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
