//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PreferDlg.h"
#include "Pop3mail.h"
#include "global.h"
#include "fileman.h"
#include "mixmaster.h"
#include "pgpmail.h"
#include "pgpfiles.h"
#include "helpdlgs.h"
#include "ImportDlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreferForm *PreferForm;
//---------------------------------------------------------------------------
bool __fastcall GetPreferences(AnsiString &PageCap)
{
   bool ok=false;
   TColor mfcolor = AppMainForm->Color;
   TPreferForm *pf = new TPreferForm(AppMainForm);
   CenterDialog(pf,AppMainForm);
   // hide pgp if no pgp dll
   pf->PgpSheet->TabVisible = HasPgp();
   pf->TabSheet4->TabVisible = HasPop3();
   TPageControl *pc = pf->PageControl1;
   int page = 0;
   for (int i=0; i<pc->PageCount; i++)
   {
      AnsiString cap = pc->Pages[i]->Caption.Trim().LowerCase();
      if (pc->Pages[i]->Caption.Trim().LowerCase()==PageCap.LowerCase() && pc->Pages[i]->TabVisible)
      {
         page = i;
         break;
      }
   }
   TTabSheet *active = pc->ActivePage = pc->Pages[page];
   if (active==pf->PgpSheet || active==pf->EdSheet)
      pf->HelpBtn->Enabled = true;

   pf->ShowModal();
   if (pf->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPreferForm::TPreferForm(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString txt;
   ini = new TStringList();
   GetAppData(ini,AppIniValues);
   // general
   txt = ini->Values[QuoteMarks];
   if (txt.IsEmpty()) txt = "> "; txt = "\""+txt+"\"";
   QuoteMarkEdit->Text = txt;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = ini->Values[StatsMinUpdates];
   // editor
   EdWrapWinBtn->Checked = ini->Values[WordWrap].ToIntDef(1);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
//   EdWrapShowBox->Checked = ini->Values[WordWrapShowBox].ToIntDef(0);
   // sending mail
   bool checked = ini->Values[SendWrapChars].ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   txt = ini->Values[SendWrapCharsCount];
   SendWrapCharEdit->Text = txt.IsEmpty()?AnsiString("65"):txt;
   SendWrapWinBtn->Checked = ini->Values[SendWrapWin].ToIntDef(1);
   SendWrapNotBtn->Checked = ini->Values[SendWrapNot].ToIntDef(0);
   DontWrapQuotes->Checked = ini->Values[DontWrapQuoted].ToIntDef(0);
   SendChainLogMax->Text = s(ini->Values[ChainLogMax].ToIntDef(16));
   SendSMTPLogMax->Text  = s(ini->Values[SMTPLogMax].ToIntDef(16));
   ReceivePOP3LogMax->Text = s(ini->Values[POP3LogMax].ToIntDef(16));
   RemailerErrChkLogMax->Text  = s(ini->Values[ErrChkLogMax].ToIntDef(16));
   RemailerTimeOut->Text = s(ini->Values[StatsTimeOut].ToIntDef(30));
   // pgp
   AnsiString pub,sec,imp;
   // keyrings
   pub = ini->Values[PgpPubRing];
   if (pub.IsEmpty() || !FileExists(pub)) pub = PgpPublicRing();
   PgpPublicKeyring->Text = pub;
   sec = ini->Values[PgpSecRing];
   if (sec.IsEmpty() || !FileExists(sec)) sec = PgpSecretRing();
   PgpSecretKeyring->Text = sec;
   imp = ini->Values[PgpImpRing];
   PgpImportKeyring->Text = imp; // imp.IsEmpty() ? PgpImportFile : imp;
   if (!FileExists(imp)) PgpImportKeyring->Enabled = false;
   // init OpenPubring dialog
   AnsiString curpubring=pubkeyfile=PgpPublicRing();
   if (FileExists(curpubring))
   {
      OpenPubring->InitialDir = ExtractFilePath(curpubring);
      OpenPubring->FileName = ExtractFileName(curpubring);
   }
   OpenPubring->Filter = "Public Keyring Files (*.pkr;*.pubkr;*.pgp)|*.PKR; *.PUBKR; *.PGP|All Files (*.*)|*.*";
   // init OpenSecring dialog
   AnsiString cursecring=seckeyfile=PgpSecretRing();
   if (FileExists(cursecring))
   {
      OpenSecring->InitialDir = ExtractFilePath(cursecring);
      OpenSecring->FileName = ExtractFileName(cursecring);
   }
   OpenSecring->Filter = "Secret Keyring Files (*.skr;*.prvkr;*.pgp)|*.SKR; *.PVRKR; *.PGP|All Files (*.*)|*.*";
   // init OpenImport dialog
   AnsiString curimpring=impkeyfile=PgpImportRing();
   if (FileExists(curimpring))
   {
      OpenImport->InitialDir = ExtractFilePath(curimpring);
      OpenImport->FileName = ExtractFileName(curimpring);
   }
   OpenImport->Filter = "Keyring Files (*.asc)|*.ASC";
   // init
   PageControl1->ActivePage = TabSheet3;
   ResetBtn->Enabled = false;
   HelpBtn->Enabled = false; // remove when 'General' tab help is installed
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (SendSMTPLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum SMTP Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendSMTPLogMax;
         CanClose = false;
         return;
      }
      if (SendChainLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum CHAIN Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendChainLogMax;
         CanClose = false;
         return;
      }
      if (ReceivePOP3LogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum POP3 Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet4;
         ActiveControl = ReceivePOP3LogMax;
         CanClose = false;
         return;
      }
      if (RemailerErrChkLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum ERROR CHECK Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerErrChkLogMax;
         CanClose = false;
         return;
      }
      if (RemailerTimeOut->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Download TIMEOUT seconds must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerTimeOut;
         CanClose = false;
         return;
      }
      Hide();
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      ini->Values[QuoteMarks] = qm;
      ini->Values[StatsMinUpdates] = StatsMinutes->Text;
      ini->Values[WorkSpaceColor] = AnsiString(ColorBox->Color);
      //if (AppMainForm->Color != ColorBox->Color)
          AppMainForm->Color  = ColorBox->Color;
      TStrings *colors = ColorDialog1->CustomColors;
      int p; while ((p=colors->IndexOf("FFFFFFFF"))>=0) colors->Delete(p);
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      ini->Values[WordWrap] = EdWrapWinBtn->Checked?"1":"0";
//      ini->Values[WordWrapShowBox] = EdWrapShowBox->Checked?"1":"0";
      // sending mail
      ini->Values[SendWrapChars] = SendWrapCharBtn->Checked?"1":"0";
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      ini->Values[SendWrapCharsCount] = AnsiString(count<16?16:count);
      ini->Values[SendWrapWin] = SendWrapWinBtn->Checked?"1":"0";
      ini->Values[SendWrapNot] = SendWrapNotBtn->Checked?"1":"0";
      ini->Values[DontWrapQuoted] = DontWrapQuotes->Checked?"1":"0";
      ini->Values[ChainLogMax] = SendChainLogMax->Text;
      ini->Values[SMTPLogMax] = SendSMTPLogMax->Text;
      ini->Values[POP3LogMax] = ReceivePOP3LogMax->Text;
      ini->Values[ErrChkLogMax] = RemailerErrChkLogMax->Text;
      ini->Values[StatsTimeOut] = RemailerTimeOut->Text;
      // pgp
      ini->Values[PgpPubRing] = PgpPublicKeyring->Text;
      ini->Values[PgpSecRing] = PgpSecretKeyring->Text;
      ini->Values[PgpImpRing] = PgpImportKeyring->Text;
      // store data
      PutAppData(AppIniValues,ini);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapBtnClick(TObject *Sender)
{
   bool enabled = SendWrapCharBtn->Checked;
   SendWrapCharEdit->Color = enabled ? clWindow:clBtnFace;
   SendWrapCharEdit->Enabled = enabled;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapCharEditExit(TObject *Sender)
{
  if (SendWrapCharEdit->Text.ToIntDef(0)<16)
     SendWrapCharEdit->Text = "16";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::StatsMinutesExit(TObject *Sender)
{
   if (StatsMinutes->Text.ToIntDef(-1)<0)
      StatsMinutes->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ColorBtnClick(TObject *Sender)
{
   ColorDialog1->Color = AppMainForm->Color;
   if (ColorDialog1->Execute() && AppMainForm->Color!=ColorDialog1->Color)
   {
       ColorBox->Color = ColorDialog1->Color;
       ApplyColorBtn->Enabled = true;
   }
   else
       ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ApplyColorBtnClick(TObject *Sender)
{
   AppMainForm->Color = ColorBox->Color;
   ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
   ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PageControl1Change(TObject *Sender)
{
   TTabSheet *active = PageControl1->ActivePage;
   if (active==PgpSheet) ActiveControl = PgpPublicKeyring;
   if (active==EdSheet ) ActiveControl = EdWrapGroup;
   HelpBtn->Enabled = active==PgpSheet || active==EdSheet;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowsePubringClick(TObject *Sender)
{
   if (OpenPubring->Execute())
      PgpPublicKeyring->Text = OpenPubring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowseSecringClick(TObject *Sender)
{
   if (OpenSecring->Execute())
      PgpSecretKeyring->Text = OpenSecring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowseImportClick(TObject *Sender)
{
   if (OpenImport->Execute())
   {
      PgpImportKeyring->Text = OpenImport->FileName;
      ResetBtn->Enabled = true;
   }
   if (FileExists(PgpImportKeyring->Text)) PgpImportKeyring->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *active = PageControl1->ActivePage;
   if (active==EdSheet)
   {
      sections = "OptionsEditor";
//sm(sections);
      OpenHelp(sections,"Editor Options","",this);
      return;
   }
   if (active==PgpSheet)
   {
      sections = "OptionsPgp\nOptionsPgpImport";
      OpenHelp(sections,"PGP Keyrings","",this);
      return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PgpImportKeyringChange(TObject *Sender)
{
   ImportBtn->Enabled = FileExists(PgpImportKeyring->Text);
}
//---------------------------------------------------------------------------
const AnsiString PgpBegPubKeyBlk = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpEndPubKeyBlk = "-----END PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpBegSecKeyBlk = "-----BEGIN PGP SECRET KEY BLOCK-----";
const AnsiString PgpEndSecKeyBlk = "-----END PGP SECRET KEY BLOCK-----";
AnsiString num(int val)
{
   AnsiString anum = AnsiString(val);
   while (anum.Length()<2) anum = " "+anum;
   return anum;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ImportBtnClick(TObject *Sender)
{
   AnsiString keystr,fname=PgpImportKeyring->Text;
   if (FileExists(fname))
   {
      int pb=0,pe=0,sb=0,se=0;
      TStringList *keys = new TStringList();
      keys->LoadFromFile(fname);
      for (int k=0; k<keys->Count; k++)
      {
         keystr = keys->Strings[k];
         if (keystr==PgpBegPubKeyBlk) pb++;
         if (keystr==PgpEndPubKeyBlk) pe++;
         if (keystr==PgpBegSecKeyBlk) sb++;
         if (keystr==PgpBegSecKeyBlk) se++;
      }
      if (pb==0 && pe==0 && sb==0 && se==0)
      {
         MsgBoxHwnd(Handle,
            s("I have scanned the import file, but found no\n")+
            s("markers indicating it is a ascii encoded PGP key\n")+
            s("block. This function only supports importing of\n")+
            s("PGP Ascii Export files."),
            "Not An Import File",
            MB_OK
         );
         return;
      }
      if (pb!=pe || sb!=se)
      {
         MsgBoxHwnd(Handle,
            s("I've scanned the import file and believe it is corrupt.\n")+
            s("By my count there are the following ascii key markers:\n\n")+
            s(" a. "+num(pb)+"  "+PgpBegPubKeyBlk+"\n")+
            s(" b. "+num(pe)+"  "+PgpEndPubKeyBlk+"\n")+
            s(" c. "+num(sb)+"  "+PgpBegSecKeyBlk+"\n")+
            s(" d. "+num(se)+"  "+PgpEndSecKeyBlk+"\n\n")+
            s("In a nutshell--the first 2 lines, a and b, must be equal.\n")+
            s("Lines c and d must also be equal. "),
            "Corrupt Import File",
            MB_OK
         );
         return;
      }
   }
   PgpKeyringChange(NULL);
   AnsiString imp,pub,sec;
   imp = PgpImportKeyring->Text;
   pub = PgpPublicKeyring->Text;
   sec = PgpSecretKeyring->Text;
   if (ImportPgpKeyrings(imp,pub,sec,this))
   {
      PgpImportKeyring->Text = imp;
      PgpPublicKeyring->Text = pub;
      PgpSecretKeyring->Text = sec;
      if (!FileExists(PgpImportKeyring->Text))
      {
         PgpImportKeyring->Enabled = false;
         ImportBtn->Enabled = false;
         ResetBtn->Enabled = false;
      }
      Application->ProcessMessages();
      Sleep(300);
      return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PgpKeyringChange(TObject *Sender)
{
   ResetBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ResetBtnClick(TObject *Sender)
{
   PgpPublicKeyring->Text = pubkeyfile;
   PgpSecretKeyring->Text = seckeyfile;
   PgpImportKeyring->Text = impkeyfile;
   ResetBtn->Enabled = false;
}
//---------------------------------------------------------------------------


